<?
// ----------------------------------------------------------------------------
// ComposeMessage()
//
// This function displays the message composition screen.
// ----------------------------------------------------------------------------

   function ComposeMessage()
   {
      global $vocab, $prefs, $config, $PHP_SELF, $sid, $socket, $index, $to, $subject, $msg, $cmd, $addressbook;

      // Display the menu bar.

      StartMenu();

      MenuOption( "$PHP_SELF?sid=$sid", $vocab["list"] );
      MenuSeparator();

      MenuOption( "$PHP_SELF?sid=$sid&cmd=config", $vocab["config"] );
      echo( "<td width=99%>&nbsp;</td>" );

      MenuOption( "$PHP_SELF?sid=$sid&cmd=logout", $vocab["logout"] );

      EndMenu();

      LoadAddressBook();

      // If this is a reply or forward then we need to read in the original
      // message headers.

      $references = "";
      if( $msg > 0 )
      {
         include( "phpost_index.php" );
         GetIndex();
         // $msg = $index[$msg - 1][number];

         fputs( $socket, "RETR $msg\r\n" );
         $line = fgets( $socket, 500 );
         if( substr( $line, 0, 1 ) == "+" )
         {
            if( $cmd == "forward" )
               $subject = "Fwd: No Subject";
            else
               $subject = "Re: No Subject";
            $replyto = "";
            $returnpath = "";
            $from = "";
            $headerlist = "";

            while( ($line = chop( fgets( $socket, 1000 ) )) != "." && $line != "" )
            {
               $headerlist = $headerlist . $line . "\n";
               if( strcasecmp( substr( $line, 0, 8 ), "SUBJECT:" ) == 0 )
               {
                  if( $cmd == "forward" )
                  {
                     if( strtoupper( substr( $line, 8, 4 ) ) != "FWD:" )
                        $subject = "Fwd: " . substr( $line, 8 );
                     else
                        $subject = substr( $line, 8 );
                  }
                  else
                  {
                     if( strtoupper( substr( $line, 8, 3 ) ) != "RE:" )
                        $subject = "Re: " . substr( $line, 8 );
                     else
                        $subject = substr( $line, 8 );
                  }
               }
               else if( strcasecmp( substr( $line, 0, 12 ), "RETURN-PATH:" ) == 0 )
                  $returnpath = substr( $line, 12 );
               else if( strcasecmp( substr( $line, 0, 9 ), "REPLY-TO:" ) == 0 )
                  $replyto = substr( $line, 9 );
               else if( strcasecmp( substr( $line, 0, 5 ), "FROM:" ) == 0 )
                  $from = substr( $line, 5 );
               else if( strcasecmp( substr( $line, 0, 11 ), "MESSAGE-ID:" ) == 0 )
                  $references = substr( $line, 11 );
            }
            if( $cmd == "reply" )
            {
               if( $replyto != "" )
                  $to = $replyto;
               else if( $from != "" )
                  $to = $from;
               else
                  $to = $returnpath;
               if( eregi( "([[:alnum:]\._-]+)@([[:alnum:]\._-]+)\.([[:alpha:]]+)", $to, $reg ) );
                  $to = $reg[1] . "@" . $reg[2] . "." . $reg[3];
            }
         }
      }

      $subject = htmlentities( $subject );

      // Display the form.

      echo( "<form enctype=\"multipart/form-data\" method=post action=$PHP_SELF>" );
      echo( "<input type=hidden name=MAX_FILE_SIZE value=2000000>" );
      echo( "<input type=hidden name=sid value=$sid>" );
      echo( "<input type=hidden name=cmd value=send>" );
      if( $references != "" )
         echo( "<input type=hidden name=references value=\"$references\">" );
      echo( "<table border=0 cellspacing=0 cellpadding=2>" );

      echo( "<tr><td class=header align=right valign=top>" );
      echo( $vocab["alias"] );
      echo( ":</td>" );
      echo( "<td><select name=nick onchange=\"document.forms[0].name.options.selectedIndex = this.options.selectedIndex;\">" );
      echo( "<option value=>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" );
      if( sizeof( $addressbook ) > 0 )
         foreach( $addressbook as $key => $value )
            echo( "<option value=\"$key\">$key" );
      echo( "</select>" );
      echo( "<select name=name onchange=\"document.forms[0].nick.options.selectedIndex = this.options.selectedIndex;\">" );
      echo( "<option value=>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" );
      if( sizeof( $addressbook ) > 0 )
      {
         foreach( $addressbook as $key => $value )
         {
            $v = $addressbook[$key];
            echo( "<option value=\"$v\">$v" );
         }
      }
      echo( "</select>" );
      echo( "<script language=javascript><!--\n" );
      echo( "function CopyAddress( field )\n" );
      echo( "{\n" );
      echo( "   var i = document.forms[0].nick.options.selectedIndex;\n" );
      echo( "   if( i == 0 )\n" );
      echo( "   {\n" );
      echo( "      alert( 'You must select an address book entry first!' );\n" );
      echo( "      return false;\n" );
      echo( "   }\n" );
      echo( "   if( field.value != '' )\n" );
      echo( "      field.value = field.value + ', ';\n" );
      echo( "   field.value = field.value + document.forms[0].nick.options[i].value;\n" );
      echo( "   document.forms[0].nick.options.selectedIndex = 0;\n" );
      echo( "   document.forms[0].name.options.selectedIndex = 0;\n" );
      echo( "}\n" );
      echo( "--></script>\n" );
      echo( "<input type=button value=\"" . $vocab["to"] . "\" onclick=\"javascript:CopyAddress( to );\"> " );
      echo( "<input type=button value=\"" . $vocab["cc"] . "\" onclick=\"javascript:CopyAddress( cc );\"> " );
      echo( "<input type=button value=\"" . $vocab["bcc"] . "\" onclick=\"javascript:CopyAddress( bcc );\"> " );
      echo( "</td></tr>" );

      echo( "<tr><td class=header align=right valign=top>" );
      echo( $vocab["to"] );
      echo( ":</td>" );
      echo( "<td><input name=to size=50 value=\"$to\"> " );

      echo( "<input type=submit value=\"" );
      echo( $vocab["send"] );
      echo( "\"><td></tr>" );

      echo( "<tr><td class=header align=right valign=top>" );
      echo( $vocab["subject"] );
      echo( ":</td>" );
      echo( "<td><input name=subject size=50 value=\"$subject\"></td></tr>" );

      echo( "<tr><td class=header align=right valign=top>" );
      echo( $vocab["cc"] );
      echo( ":</td>" );
      echo( "<td><input name=cc size=50></td></tr>" );

      echo( "<tr><td class=header align=right valign=top>" );
      echo( $vocab["bcc"] );
      echo( ":</td>" );
      echo( "<td><input name=bcc size=50></td></tr>" );

      echo( "<tr><td class=plain colspan=2>" );
      echo( $vocab["sendhtml"] );
      echo( " <input type=checkbox name=ashtml>&nbsp;&nbsp;" );
      echo( $vocab["ccself"] );
      echo( " <input type=checkbox name=ccself>&nbsp;&nbsp;" );
      echo( "</td></tr>" );

      echo( "<tr><td colspan=3><textarea name=body rows=15 cols=80>" );
      if( $msg > 0 && $line != "." )
      {
         if( $cmd == "forward" )
         {
            echo( "-- START OF FORWARDED MESSAGE --\n\n" );
            echo( "$headerlist\n" );
            while( ($line = chop( fgets( $socket, 10000 ) )) != "." )
            {
               if( strncmp( $line, "..", 2 ) == 0 )
                  $line = substr( $line, 1 );
               echo( htmlentities( $line ) );
               echo( "\n" );
            }
            echo( "-- END OF FORWARDED MESSAGE --\n" );
         }
         else while( ($line = chop( fgets( $socket, 10000 ) )) != "." )
         {
            if( strncmp( $line, "..", 2 ) == 0 )
               $line = substr( $line, 1 );
            echo( "> " );
            echo( htmlentities( $line ) );
            echo( "\n" );
         }
      }

      $x = "phpost_prefs/" . strtr( $prefs["username"] . "@" . $prefs["pop"], "/", "_" ) . ".sig";
      if( file_exists( $x ) &&
          filesize( $x ) > 0 )
      {
         echo( "\n\n-- \n" );
         readfile( $x );
      }
      echo( "</textarea></td></tr>" );

      if( $prefs["attach"] > 0 )
      {
         echo( "<tr><td></td>" );
         echo( "<td class=plain>" );
         $x = "<select name=encoding><option value=base64>base64<option value=uuencoding>uuencoding</select>";
         printf( $vocab["encoding"], $x );
         echo( "</td></tr>\n" );
      }

      for( $i = 1; $i <= $prefs["attach"]; $i++ )
      {
         echo( "<tr><td align=right class=plain>$i.</td>" );
         echo( "<td><input name=attach$i size=50 type=file></td></tr>" );
      }

      echo( "</table>" );
      echo( "</form>" );
   }
?>
